#include <iostream>
#include <list>
#include <algorithm>
#include <map>
#include <iomanip>

using string = std::string;
using dlist = std::list<double>;
using wordstat = std::map<string,dlist*>;

//Place in header!
template <typename T>
void printm(T m){
  std::cout << m;
}

template <typename T>
void printlm(T m){
  printm(m);
  printm("\n");
}

int prompti(string,bool*);
double promptd(string,bool*);
string prompts(string,bool*);
double avg(std::list<double>*);
double med(std::list<double>*);

int main() {
  printlm("Get stats of inputs:");
  bool s1 {};
  bool s2 {};
  wordstat stat {};
  do {,
    auto v1 = prompts("Enter a word: ", &s1);
    auto v2 = promptd("Enter a double: ", &s2);
    if (s1 && s2) {
      if (stat[v1] == null) {
        stat[v1] = new dlist {};
      }
      stat[v1].push_back(v2);
    }
  } while (s1 && s2);
  
  return 0;
}

int prompti(string message, bool *status) {
  int tr {};
  *status = false;
  std::cout << message;
  if (!(std::cin >> tr)){
    std::cin.clear();
    std::cin.ignore();
    return 0;
  }
  *status = true;
  return tr;
}

double promptd(string message, bool *status) {
  double tr {};
  *status = false;
  std::cout << message;
  if (!(std::cin >> tr)){
    std::cin.clear();
    std::cin.ignore();
    return 0.0;
  }
  *status = true;
  return tr;
}

string prompts(string message, bool *status) {
  string tr {""};
  *status = false;
  std::cout << message;
  if (!(std::cin >> tr)){
    std::cin.clear();
    std::cin.ignore();
    return "";
  }
  *status = true;
  return tr;
}

double avg(std::list<double> *values) {
  if (values->size() < 1) return 0.0;
  double sum {};
  for (const auto c : *values) sum += c;
  return sum / values->size();
}

double med(std::list<double> *values) {
  if (values->size() < 1) return 0.0;
  sort(values->begin(), values->end());
  auto hw {values->size()/2};
  if (values->size()%2 == 1) {
    return values->at(hw);
  } else {
    return (values->at(hw - 1) + values->at(hw)) / 2.0;
  }
}
